#!/usr/bin/python
# By: kaivalagi - 04/09/2010
# Depends: python-dateutil <<<--- available in the repos
# args expected are YYYYMMDD YYYYMMDD
import sys, datetime, traceback
from dateutil.relativedelta import *

def print_usage():
	print "Usage: conkyDateDiff <startdate> [<enddate>]\n  If no end date given it is assumed to be today.\n\n  examples:\n\n    $ conkyDateDiff 20080105 20091225\n    1 year, 11 months, 20 days"

try:

	# what files do we need to process
	if "-h" in sys.argv or "--help" in sys.argv or len(sys.argv) < 2:
		print_usage()
	else:

		# retrieve args passed in, form date types and get difference

		startdate=sys.argv[1]
		startdate = datetime.datetime(int(startdate[0:4]),int(startdate[4:6]),int(startdate[6:8]))

		if len(sys.argv) == 3:
			enddate=sys.argv[2]
			enddate = datetime.datetime(int(enddate[0:4]),int(enddate[4:6]),int(enddate[6:8]))
		else:
			enddate = datetime.datetime.today()

		if enddate > startdate:
			future = False
			rdelta = relativedelta(enddate,startdate)
		else:
			rdelta = relativedelta(startdate, enddate)
			future = True

		# get nice tidy string output sorted out

		output = ""

		if rdelta.years > 0:
			if rdelta.years == 1:
				suffix = " yr  "
			else:
				suffix = " yrs "

			output = output + str(rdelta.years) + suffix

		if rdelta.months > 0:
			if rdelta.months == 1:
				suffix = " mth  "
			else:
				suffix = " mths "

			output = output + str(rdelta.months) + suffix

		if rdelta.days > 0:
			if rdelta.days == 1:
				suffix = " day "
			else:
				suffix = " days"

			output = output + str(rdelta.days) + suffix

		output = output.rstrip(", ")

		print output

except:
	print 80*"="
	print_usage()
	print 80*"="
	print traceback.format_exc()
	print 80*"="

