#!/usr/bin/python
# By: kaivalagi - 04/09/2010
# Depends: python-dateutil <<<--- available in the repos
# args expected are YYYYMMDD YYYYMMDD
import sys, datetime, traceback

negative_displayed = False # change to true to show negative days when difference in the past

def print_usage():
	print "Usage: conkyDaysDiff <startdate> [<enddate>]\n  If no end date given it is assumed to be today.\n\n  examples:\n\n    $ conkyDaysDiff 20080105 20091225\n    720"

try:

	# what files do we need to process
	if "-h" in sys.argv or "--help" in sys.argv or len(sys.argv) < 2:
		print_usage()
	else:

		# retrieve args passed in, form date types and get difference

		startdate=sys.argv[1]
		startdate = datetime.datetime(int(startdate[0:4]),int(startdate[4:6]),int(startdate[6:8]))

		if len(sys.argv) == 3:
			enddate=sys.argv[2]
			enddate = datetime.datetime(int(enddate[0:4]),int(enddate[4:6]),int(enddate[6:8]))
		else:
			enddate = datetime.datetime.today()

		if enddate > startdate:
			datediff = enddate - startdate
			future = False
		else:
			datediff = startdate - enddate
			future = True

		# get nice tidy string output sorted out
		if negative_displayed == True and future == False:
			print str(datediff.days * -1)
		else:
			print str(datediff.days)

except:
	print 80*"="
	print_usage()
	print 80*"="
	print traceback.format_exc()
	print 80*"="

